patient/urls.py
from django.conf import settings
from django.contrib.auth import views as auth_views
from django.urls import path

from patient.views import updatePatient

from . import views

app_name = "patient"

urlpatterns = [
    path("patient-list/", views.patientList, name="patient-list"),
    path("show-details/<str:pk>", views.showDetails, name="show-details"),
    path("patient-register/", views.registerPatient, name="patient-register"),
    path("patient-update/<str:pk>", updatePatient, name="patient-update",),
]

project_config/urls.py
from django.conf import settings
from django.conf.urls import url
from django.conf.urls.static import static
from django.contrib import admin
from filebrowser.sites import site
from django.contrib.auth import views as auth_views
from django.urls import include, path

from . import views

urlpatterns = (
    [
        path('admin/filebrowser/', site.urls),
        path("admin/", admin.site.urls),
        path("", views.home, name="home"),
        path("", include("collaborator.urls", namespace="collaborator")),
        path("", include("patient.urls", namespace="patient")),
        path("", include("appointment.urls", namespace="appointments")),
    ]
    + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
    + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
)

patient/models.py
import random

from django.db import models
from django.utils.translation import gettext_lazy as _


# Create your models here.
class Patient(models.Model):
    class Meta:
        db_table = "patient"
        verbose_name = _("patient")
        verbose_name_plural = _("patient")

    SEXO_CHOICES = (
        ('M', _('Male')),
        ('F', _('Female')),
    )

    name = models.CharField(max_length=100, null=True, blank=True, verbose_name=_('Name'))
    medical_record_number = models.IntegerField(default=random.randint(1, 25052020), null=True, blank=True,
                                                editable=False, verbose_name=_('Medical record number'))
    photo = models.ImageField(upload_to='photos', max_length=200, null=True, blank=True)
    rg_document = models.CharField(max_length=14, null=True, blank=True, verbose_name=_('rg document'))
    cpf_document = models.CharField(max_length=14, null=True, blank=True, verbose_name=_('cpf document'))
    date_of_birth = models.DateField(max_length=14, null=True, blank=True, verbose_name=_('Date of birth'))
    phone_number = models.CharField(max_length=15, blank=True, null=True, verbose_name=_('phone number'))
    landline = models.CharField(max_length=15, blank=True, null=True, verbose_name=_('landline'))
    email = models.EmailField(max_length=254, blank=True, null=True)
    address = models.CharField(max_length=254, blank=True, null=True, verbose_name=_('Address'))
    sexo = models.CharField(max_length=1, blank=True, null=True, choices=SEXO_CHOICES)
    updateAt = models.DateTimeField(null=False, blank=False, editable=False, auto_now=True)
    createAt = models.DateTimeField(null=False, blank=False, editable=False, auto_now_add=True)

    def __str__(self):
        return self.name

    def birthday(self):
        _date_of_birth = self.date_of_birth.strftime('%d/%m/%Y')
        return _date_of_birth

patient/views.py
from django.contrib import messages
from django.contrib.auth.decorators import login_required
from django.core.paginator import EmptyPage, PageNotAnInteger, Paginator
from django.shortcuts import redirect, render
from django.utils.translation import gettext_lazy as _
from django.views.decorators.http import require_GET

from patient.form import PatientForm
from patient.models import Patient


@login_required
def registerPatient(request):
    form = PatientForm()
    if request.method == 'POST':
        form = PatientForm(request.POST, request.FILES)
    try:
        if form.is_valid():
            form.save()
            form = PatientForm()
            messages.success(request, _("Patient was successfully Saved!"))
            return redirect("patient:patient-list")
        else:
            context = {'form': form}
            return render(request, 'patient/patient-register.html', context)
    except Exception:
        messages.warning(request, _('Error Form'))


@login_required
def updatePatient(request, pk):
    patient = Patient.objects.get(id=pk)
    if request.method == "POST":
        form = PatientForm(request.POST, instance=patient)
        if form.is_valid():
            form.save()
            messages.success(request, _("Patient was successfully updated!"))
            return redirect("patient:patient-list")
        else:
            messages.warning(request, _("Please correct the error below."))
    else:
        form = PatientForm(instance=patient)

        context = {

            "form": form,
        }
    return render(request, "patient/patient-register.html", context)


@require_GET
def show_total_values(request):
    patients = Patient.objects.all()
    return patients


@login_required
@require_GET
def patientList(request):
    search = request.GET.get('search')

    if search:
        patients = Patient.objects.filter(name__icontains=search)
    else:
        patients = Patient.objects.all().order_by('name')
        paginator = Paginator(patients, 10)
        page = request.GET.get('page', 1)
        try:
            patients = paginator.get_page(page)
        except PageNotAnInteger:
            patients = paginator.get_page(2)
        except EmptyPage:
            patients = paginator.get_page(paginator.num_pages)
        context = {'patients': patients,
                   'show_total_values': show_total_values(request)}
    return render(request, "patient/patient-list.html", context)


@login_required
@require_GET
def researchField(request, name):
    context = {'researchField': Patient.objects.filter(pacient__name_icontains=name)}
    return render(request, 'patient/show-details.html', context)


@login_required
@require_GET
def showDetails(request, pk):
    context = {'showDetails': Patient.objects.filter(id=pk)}
    return render(request, 'patient/show-details.html', context)

patient/templates/patient/patient-list.html
{% extends 'base/base.html' %} {% load static %} {% block content %}

<div class="row wrapper border-bottom bg-white page-heading" style="margin-bottom: 30px;">
    <div class="col-lg-10">
        <h2 class="text-muted profile">Lista de pacientes cadastrados</h2>
    </div>
    <p type="button" class="btn btn-info btn-sm" style="float:right;">
       Total de pacientes <span class="badge badge-light" style="font-size:14px; margin-left:10px;">
        {{ show_total_values|length }}</span>
    </p>
</div>
<div class="container">
    <form action="" method="GET">
    <div class="row">
        <td>
            <a class="fa fa-user-plus btn btn-info" href="{% url 'patient:patient-register' %}"
               style="margin-bottom: 10px;">
                Novo paciente</a>
        </td>

            <div class="form-group align-right col-md-auto mb-2">
                <label class="sr-only" for="search"></label>
                <input class="form-control" id="search" name="search" placeholder="Pesquisar paciente" type="text">
            </div>

            <button class="btn btn-primary mb-2" type="submit">Pesquisar</button>

    </div>
        </form>
</div>
<div class="table-responsive-md">
    <table class="table table-hover table-bordered">
        <thead>
        <tr>
            <th scope="col">#</th>
            <th scope="col">Nome</th>
            <th scope="col">Celular</th>
            <th scope="col">Telefone Fixo</th>
            <th scope="col">E-mail</th>
            <th scope="col">N° Prontuário</th>
        </tr>
        </thead>
        {% for patient in patients %}
        <tbody>
        <th scope="row">{{ patient.id }}</th>
        <td>
            <a class="text-muted" href="{% url 'patient:show-details' patient.id %}"
               title="Visualizar mais detalhes">{{ patient.name }}</a></td>
        {% if patient.phone_number %}
        <td>{{ patient.phone_number }}</td>
        {% else %}
        <td><span class="badge badge-danger">Não possui</span></td>
        {% endif %} {% if patient.landline %}
        <td>{{ patient.landline }}</td>
        {% else %}
        <td><span class="badge badge-danger">Não possui</span></td>
        {% endif %} {% if patient.email %}
        <td>{{ patient.email }}</td>
        {% else %}
        <td><span class="badge badge-danger">Não possui</span></td>
        {% endif %}

        <td>{{ patient.medical_record_number }}</td>

        <td>
            <a class="btn btn-info fa fa-edit"
               href="{% url 'patient:patient-update' patient.id %}?medical_record_number={{ patient.medical_record_number }}" title="Editar paciente"></a>
        </td>
        </tbody>
        {% empty %}
        <div class="alert alert-warning" role="alert ">Nenhum paciente cadastrado.</div>
        {% endfor %}
    </table>
</div>
{% if patients.has_other_pages %}
<nav aria-label="Page navigation example">
    <ul class="pagination justify-content-center">
        {% if patients.has_previous %}
        <li class="page-item">
            <a aria-label="Previous" class="page-link" href="?page={{ patients.previous_page_number }}">
                <span aria-hidden="true">&laquo;</span>
                <span class="sr-only">Previous</span>
            </a>
        </li>
        {% else %}
        <li class="page-item disabled">
            <a class="page-link" href="#" tabindex="-1">&laquo;</a>
        </li>
        {% endif %}
        {% for i in patients.paginator.page_range %}
        {% if patients.number == i %}
        <li class="page-item active">
            <a class="page-link" href="#">{{ i }} <span class="sr-only">(current)</span></a>
        </li>
        {% else %}
        <li><a href="?page={{ i }}">{{ i }}</a></li>
        {% endif %}
        {% endfor %}
        {% if patients.has_next %}
        <li class="page-item">
            <a aria-label="Next" class="page-link" href="?page={{ patients.next_page_number }}">
                <span aria-hidden="true">&raquo;</span>
                <span class="sr-only">Next</span>
            </a>
        </li>
        {% else %}
        <li class="page-item disabled">
            <a class="page-link" href="#" tabindex="-1">&raquo;</a>
        </li>
        {% endif %}
    </ul>
</nav>
{% endif %}
{% endblock %}

patient/templates/patient/patient-register.html
{% extends 'base/base.html' %}
{% block content %}
{% load static %}


<div class="row wrapper border-bottom bg-white page-heading" style="margin-bottom: 30px;">
    <div class="col-lg-10">
        <h2 class="text-muted profile">Formulario de cadastro de pacientes</h2>
    </div>
</div>
<form method='POST' enctype="multipart/form-data" novalidate>
    {% csrf_token %}
    <div class="col-md-12">
        <div class="row">
            <div class="col-6">
                <div class="form-group">
                    <label class="sr-only">Name</label>
                    {{ form.name }}
                </div>
            </div>
            <div class="col-6">
                <div class="form-group">
                    <label class="sr-only">medical_record_number</label>
                    {{ form.medical_record_number }}
                </div>
            </div>
            <div class="col-3">
                <div class="form-group">
                    <label class="sr-only">RG</label>
                    {{ form.rg_document }}
                </div>
            </div>

            <div class="col-3">
                <div class="form-group">
                    <label class="sr-only">CPF</label>
                    {{ form.cpf_document }}
                </div>
            </div>

            <div class="col-3">
                <div class="form-group">
                    <label class="sr-only">sexo</label>
                    {{ form.sexo }}
                </div>
            </div>

            <div class="col-3">
                <div class="form-group">
                    <label class="sr-only">date of birth</label>
                    {{ form.date_of_birth }}
                </div>
            </div>


            <div class="col-3">
                <div class="form-group">
                    <label class="sr-only">phone_number</label> {{ form.phone_number }}
                </div>
            </div>

            <div class="col-3">
                <div class="form-group">
                    <label class="sr-only">landline</label> {{ form.landline }}
                </div>
            </div>

            <div class="col-md-6">
                <div class="form-group">
                    <label class="sr-only">E-mail</label> {{ form.email }}
                </div>
            </div>

            <div class="col-12">
                <div class="form-group">
                    <label class="sr-only">address</label>
                    {{ form.address }}
                </div>
            </div>

            <div class="col-12">
                <div class="form-group">
                    <label class="labelUp">Foto</label>
                    {{ form.photo }}
                </div>
            </div>
        </div>
        <div class="row-cols-6">
            <div class="form-group">
                <button type='submit' class='btn btn-info'>Salvar</button>
            </div>
        </div>
    </div>
</form>

{% endblock %}

patient/templates/patient/show-details.html
{% extends 'base/base.html' %} {% load static %} {% block content %}

<link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.0.8/css/all.css" integrity="sha384-3AB7yXWz4OeoZcPbieVW64vVXEwADiYyAEhwilzWsLw+9FgqpyjjStpPnpBO8o8S" crossorigin="anonymous">

<div class="row wrapper border-bottom bg-white page-heading">
    <div class="col-lg-10">
        <h2 class="text-muted profile">Perfil do Paciente</h2>
        <p class="text-muted" style="margin-bottom: 10px;font-size: 15px;"><strong>Informações sobre o
                Paciente</strong></p>
    </div>
</div>
<section class="container mt-4 mb-4">
    <div class="container">
        <div class="row mb-3">
            <div class="col-md-6">
                <div class="d-flex flex-row border rounded">
                    {% for patient in showDetails %}
                    <div class="p-0 w-25">
                        <a href="{{ patient.photo.url }}" target="_blank"><img src="{{ patient.photo.url }}" height="10" width="200" style="border-radius: 50%;" class="img-thumbnail border-0"></a>
                        </img>
                        <ul style="list-style: none; margin-left: -20px; font-size: 20px;">
                            <strong>
                                <li class="text-muted">{{ patient.medical_record_number }}</li>
                            </strong>
                        </ul>
                    </div>
                    <div class="pl-3 pt-2 pr-2 pb-2 w-75">
                        <h4 class="text-muted">{{patient.name}}</h4>
                        <ul class="m-0 float-left" style="list-style: none; margin:0; padding: 0">
                            {% if patient.email %}
                            <li class="text-muted"><strong>E-mail:</strong> {{ patient.email }} </li>
                            {% else %}
                            <li class="text-muted"><strong>E-mail:</strong><span class="badge badge-danger"> Não possui </span></li>
                            {% endif %}
                            <li class="text-muted"><strong>Aniversário: </strong>{{ patient.date_of_birth }} </li>
                            <li class="text-muted"><strong>Sexo: </strong>{{ patient.sexo }} </li>
                            <li class="text-muted"><strong>Endereço: </strong> {{ patient.address }} </li>
                            <li class="text-muted"><strong>CPF: </strong> {{ patient.cpf_document }} </li>
                            <li class="text-muted"><strong>RG: </strong> {{ patient.rg_document }} </li>
                            <li class="text-muted"><strong>Paciente Desde: </strong> {{ patient.createAt | date:'d/m/Y' }} </li><br><br>
                        </ul>
                        <p class="text-right m-0"><a href="{% url 'patient:patient-update' patient.id %}" class="btn btn-primary"><i class="far fa-user"></i> Atualizar dados</a></p>
                    </div>
                </div>
                {% endfor %}
            </div>
        </div>
    </div>
</section>

{% endblock %}